# Dec 16, 2018
# Koji Ota


# https://qiita.com/rubytomato@github/items/51779135bc4b77c8c20d

set ::_style(graph.style01) {
	-charset		"UTF-8"
	-bgcolor		"#343434"
	-fontcolor		white
	-fontsize		12
	-style			"filled"
	-rankdir		LR
}

set ::_style(node.style01) {
	-colorscheme	"rdylgn11"
	-style			"solid,filled"
	-fontcolor		white
	-fontname		"Meiryo UI"
	-fontsize		9
	-color			white
	-fillcolor		#228822
}

set ::_style(edge.style01) {
	-style			solid
	-color			white
	-fontname		"Meiryo UI"
	-fontsize		9
}

set ::_style(subgraph.style01) {
	-style			"solid,filled"
    -labelloc		"t"
    -labeljust		"l"
    -fillcolor		"#aaaaaa"
}

##

proc opts2params { opts params } {
	upvar $params x
	foreach { optname optvalue } $opts {
		set x([string range $optname 1 end]) $optvalue
	}
}

proc def { name args } {
	if {[llength $args] > 0} {
		set ::_style($name) [lindex $args 0]
	}
	return ""
}

proc load { style name args } {
	opts2params $::_style($style.$name) prop

	if {[llength $args] > 0} {
		opts2params $::_style($style.$name) u
		foreach pname [array names u] {
			set prop($pname) $u($pname)
		}
	}

	set body ""
	switch $style {
		graph -
		node -
		edge {
			set body "$style \["
			foreach pname [array names prop] {
				append body "$pname=\"$prop($pname)\", " \n
			}
			append body "\];"
		}
		subgraph {
			foreach pname [array names prop] {
				append body "$pname=\"$prop($pname)\"; " \n
			}
		}
	}
	
	return $body
}

proc style { args } {
	# find -base option
	foreach { optname optvalue } $args {
		if {$optname == "-base"} {
			opts2params $::_style($optvalue) prop
		}
	}
	
	# eval option except -base
	foreach { optname optvalue } $args {
		if {$optname != "-base"} {
			set prop([string range $optname 1 end]) $optvalue
		}
	}
	
	set body "\[ "
	foreach pname [array names prop] {
		append body "$pname=\"$prop($pname)\" "
	}
	append body "\];"
	return $body
}


proc preprocess { tdd } {
	set dot [subst $tdd]
	return $dot
}
